﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq; 
using System.Text;
using System.Windows.Forms;

namespace Signpad
{
    public partial class InputDialog : Form
    {
        public InputDialog()
        {
            InitializeComponent();
        }
        public Rectangle GetRectangle()
        {
            int x1, y1, x2, y2;
            x1 = this.GetCoord(this.tbPoint1x);
            y1 = this.GetCoord(this.tbPoint1y);
            x2 = this.GetCoord(this.tbPoint2x);
            y2 = this.GetCoord(this.tbPoint2y);

            return new Rectangle(x1, y1, x2 - x1, y2 - y1);
        }

        private bool ValidateFields()
        {
            int x1 = this.GetCoord(this.tbPoint1x);
            int y1 = this.GetCoord(this.tbPoint1y);
            int x2 = this.GetCoord(this.tbPoint2x);
            int y2 = this.GetCoord(this.tbPoint2y);

            if (x1 < 0 || y1 < 0 || x2 < 0 || y2 < 0)
            {
                MessageBox.Show("Must be integer greater than zero");
                return false;
            }
            if (x1 >= x2)
            {
                MessageBox.Show("Upper left x must be less than lower right x");
                return false;
            }

            if (y1 >= y2)
            {
                MessageBox.Show("Upper left y must be less than lower right y");
                return false;
            }
            if (x2 > 640)
            {
                MessageBox.Show("Lower right X must not exceed 640");
                return false;
            }
            if (y2 > 480)
            {
                MessageBox.Show("Lower right Y must not exceed 480");
                return false;
            }

            return true;
        }

        private int GetCoord(TextBox box)
        {
            int val;
            if (this.TryParse(box.Text, out val))
                return val;

            return -1;
        }

        private bool TryParse(string val, out int result)
        {
            result = int.MinValue;
            try
            {
                result = int.Parse(val);
                return true;
            }
            catch (FormatException)
            {
            }
            return false;
        }

        private void btOk_Click(object sender, EventArgs e)
        {
            if (!this.ValidateFields())
                return;

            this.DialogResult = DialogResult.OK;
            this.Close();
        }
        
    }
}
